/**
 * 
 * @author pinkred
 *
 * XList Ʈ ⺻ Ǵ Լ̴.  Ŭ  ӵǴ°
 * XPopup, XListField ִ. 
 * 
 * - setBounds   ־ Ѵ.
 */


import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

import com.xce.lcdui.Toolkit;

public class PinkList
{

/*
** --------------------------------------------------------------------------------
**	FINAL
** --------------------------------------------------------------------------------
*/
    public final static int EMPTY 	= 1;
    public final static int DEFAULT = 2;
    public final static int ICON 	= 3; //    쿡 տ ѹƮ   ִ´. 

	// ̷ Ѱ ˾Ƽ...	
    // ٵ   Ұ쿡      ũ⸸ŭ ÷  ̴.
	final int LIST_ITEM_WIDTH		= 16;	// Ʈ ڿ ڿ 
	
/*
** --------------------------------------------------------------------------------
**	FIELD
** --------------------------------------------------------------------------------
*/
	// ٴ  ..Ϲ Ʈ ũ  1 ũ ϴµ. 
	int LIST_PER_LINEHEIGHT	= Toolkit.FONT_HEIGHT + 1;

	int list_x;			// List X
	int list_y;			// List Y
	int list_width;		// List Width
	int list_height;	// List Height
	
    int margin_left;	// Margin  LEFT
	int margin_right;	// Margin  RIGHT
	int margin_top;		// Margin  TOP
	int margin_bottom;	// Margin  BOTTOM

	int lineFirst;		//  ȭ鿡 ̴  Line
	int lineCur;		//  õ Line
	int lineMax;		// Ʈ ü  

	int list_anchor;		// Ÿ ɼ
	int maxLinePerHeight;	// LIST_HEIGHT  ִ  

	boolean gapHeightOfListAndReal;	// List y Űܾ Ұ.


	char[][] list_text;		// Ʈ  迭
	char[] list_num = {'', '', '', '', '', '', '', '', '', ''};	// List  迭

	int colorFont 		= 0x000000;		// Ʈ Į
	int colorSelFont 	= 0x1f3f7f;		// õ Ʈ Į
	int colorSelBar 	= 0x9fdfff ;	// ù Į
	int colorBack 		= 0xffffff;		//  .

	Canvas canvas;
    XListType xListType;
    
	PinkComponentListener xComponentListener;
	
/*
** --------------------------------------------------------------------------------
**	METHOD
** --------------------------------------------------------------------------------
*/
	
	/**
	 * 
	 */
	PinkList(Canvas canvas)
	{
	    this.canvas = canvas;
	}
    
    /**
     * ޸ .
     *  ش List ׳ Ѱ־  ۷ ޾
     * ̹  ش List  īؼ ̿Ѵ.
     * ׷Ƿ ۽ø ʱȭ ־ Ѵ.
     *  ִ. װ  ϴ ŸϷ ϸ ̴.
     *
     */
    public void free()
    {

        if(list_text != null)
        {
            for(int i = 0; i < lineMax; i++)
                list_text[i] = null;

            list_text = null;
        }
    }
    
    /**
     * Ʈ Ű ̺Ʈ ش ʸ ̿Ͽ Ѵ.
     * @param keyCode
     */
    protected void keyNotify(int keyCode)
    {
        if(xComponentListener != null)
            xComponentListener.keyNotify(keyCode);
    }

    /**
     *  ִ μ Ѵ.
     *
     */
    void setMaxLinePerHeight()
    {
        // Height  ִ ٰ մϴ.
        // ںκ ȭ鿡  ̴ ٷ ϴ Դϴ.(̺κ ٰ ٽ)
        maxLinePerHeight = getRealHeight() / LIST_PER_LINEHEIGHT + 
            ((getRealHeight() % LIST_PER_LINEHEIGHT > 0)?1:0);
    }
    
	/**
	 * Ʈ  ´.
	 * 
	 * @param x
	 * @param y
	 * @param width
	 * @param height
	 */
	public void setBounds(int x, int y, int width, int height)
	{
		list_x = x;
		list_y = y;
		list_width = width;
		list_height = height;
        
        setMaxLinePerHeight();
	}
	
	/**
	 * margin ũ⸦ ´.
	 * margin setBounds  Ȥ  ص  ϸ
	 *   setBounds  ϵ . 
	 * 
	 * @param top
	 * @param right
	 * @param bottom
	 * @param left
	 */
	public void setMargin(int top, int right, int bottom, int left)
	{
		margin_top 		= top;
		margin_right 	= right;
		margin_bottom 	= bottom;
		margin_left 	= left;
		
        setMaxLinePerHeight();
	}

	/**
	 * Ʈ  ̸ Ѵ.
	 * ⺻ ⺻Ʈ + 1  ִ.
	 * 
	 * @param height
	 */
	public void setListPerLineHeight(int height)
	{
	    LIST_PER_LINEHEIGHT = height;
        
        setMaxLinePerHeight();
	}
	
	/**
	 *   Ʈ ̺Ʈ ĵ ֱ ؼ .
	 *   1, 2, 3  ȣ ̺Ʈ ؼ.
	 * @param aTimerListener
	 */
	public void setComponentListener(PinkComponentListener xComponentListener)
	{

		this.xComponentListener = null;
		this.xComponentListener = xComponentListener;
	}
	
	/**
	 * Ʈ setѴ.
	 * @param list
	 * @param count
	 * @param anchor
	 */
	public void setChars(char[][] list, int count, int anchor)
	{
		int length = 0;

		// ó
		if(list == null || list.length < count || count <= 0)
			throw new ArrayIndexOutOfBoundsException();

		free();

		//  ʱȭ
		lineFirst = 0;
		lineCur = 0;
		lineMax = count;
		gapHeightOfListAndReal = false;
		this.list_anchor = anchor;
        xListType = null;
        
        // ⼭ ο Ÿ ٲ𶧸  Ұ.
        // ƴϸ ̸    Ѱܸ ٰ ε .
        //  𸣰ڻ.
        switch(anchor)
        {
            case EMPTY:
                xListType = new XListTypeOfEmpty();
                break;
                
            case DEFAULT:
                xListType = new XListTypeOfDefault();
                break;
                
            case ICON:
                xListType = new XListTypeOfIcon();
                break;
        }

		list_text = new char[lineMax][];

		for(int i = 0; i < lineMax; i++)
		{
			length = list[i].length;
			list_text[i] = new char[length];

			System.arraycopy(list[i], 0, list_text[i], 0, length);
		}
	}


	/**
	 * ϸ String  .
	 * @param list
	 * @param count
	 * @param anchor
	 */
	public void setString(String[] list, int count, int anchor)
	{
		// ó
		if(list == null || list.length < count || count <= 0)
			throw new ArrayIndexOutOfBoundsException();

		free();

		//  ʱȭ
		lineFirst = 0;
		lineCur = 0;
		lineMax = count;
		gapHeightOfListAndReal = false;
		this.list_anchor = anchor;
		
		list_text = new char[lineMax][];

		for(int i = 0; i < lineMax; i++)
			list_text[i] = list[i].toCharArray();
	}

	/**
	 * Į Ѵ. ٵ ̰Ϳܿؾ Į ְ   Į 
	 * ִ.  ٲٵ .
	 * 
	 * @param back	
	 * @param font	
	 * @param selFont	õ 
	 * @param selBar	ù
	 */
	public void setColor(int back, int font, int selFont, int selBar)
	{
	    colorBack = back;
	    colorFont = font;
	    colorSelFont = selFont;
	    colorSelBar = selBar;
	}
    
    /**
     * ȭ  .
     * 
     * @return
     */
    int getLastLine()
    {
        // List   ã´.
        // ⺻ ü   maxLinePerHeight ۰ų    ü ǰ
        // ׷  ù°ο maxLinePerHeight ŭ ؼ   Ѵ.
        if(lineMax <= maxLinePerHeight || lineMax <= lineFirst + maxLinePerHeight)
            return lineMax;
        else
            return lineFirst + maxLinePerHeight;
    }

    int getRealX()
    {
        return list_x + margin_left;
    }
    
    int getRealY()
    {
        int result = list_y + margin_top;
        
        if(gapHeightOfListAndReal)
            result -= getGapHeightOfListAndReal();
        
        return result;
    }
    
    /**
     * list ̿ ȭ ü  X Ʈ ̸ ؼ ش ..
     * @return
     */
    int getGapHeightOfListAndReal()
    {
        return maxLinePerHeight * LIST_PER_LINEHEIGHT - list_height;
    }
    
    int getMaxLinePerHeight()
    {
        return LIST_PER_LINEHEIGHT;
    }
    
    int getTextY(int line)
    {
        return getRealY() + LIST_PER_LINEHEIGHT * line;
    }
    
    int getSelLine()
    {
        return lineCur - lineFirst;
    }
    
    int getGapFontHeightOfLine()
    {
        return (LIST_PER_LINEHEIGHT - Toolkit.FONT_HEIGHT) >> 1;
    }
	
    int getRealHeight()
    {
        return list_height - margin_top - margin_bottom;
    }
    
    int getRealWidth()
    {
        return list_width - margin_left - margin_right;
    }
    
    int getWidth()
    {
        return list_width;
    }
    
    int getHeight()
    {
        return list_height;
    }
    
	/**
	 *  õ .
	 * @return
	 */
	public int getSelect()
	{
		return lineCur;
	}

	/**
	 *  õ .
	 * @return
	 */
	public char[] getChars()
	{
		return xListType.getChars();
	}
    
	/**
	 *  String   .
	 * @return
	 */
	public String getString()
	{
		return (new String(getChars()));
	}
	
    /**
     * ȭ鿡 ׸.
     * 
     * @param g
     */
    public void paint(Graphics g)
    {
        int line = lineFirst;
        int k = 0;
        while(line < getLastLine())
        {
            //  õ ϰ.
            if(k == getSelLine())
            {
                xListType.drawBar(g, list_x, getTextY(k));
                xListType.drawList(g, getRealX(), getTextY(k++), line++, colorSelFont);
            }else
                xListType.drawList(g, getRealX(), getTextY(k++), line++, colorFont);
        }
    }
    
	/**
	 * 
	 * @param keyCode
	 */
	protected void keyPressed(int keyCode)
	{
		switch(keyCode)
		{
		    // ش ȣŰ .
		    //    ȣ ̵ϰ Ŀ
		    // Ű  ̴ ǵ.
		    //  ȭ  ȣ  ָ.
		    // ȭ  ̵ϰ Ŀ ̱Ⱑ ָϱ ..
		    // ȭ鿡 Ⱥ̴  ̵   ȹ ̽ ʿ
		    //   Ⱥ̴  ̰ Ŀ ̵ϴ ͵ ..
		    // 10 Ѵ° Timer ̿ؾ ϴµ  ..׳ .
			case Canvas.KEY_NUM1:
			case Canvas.KEY_NUM2:
			case Canvas.KEY_NUM3:
			case Canvas.KEY_NUM4:
			case Canvas.KEY_NUM5:
			case Canvas.KEY_NUM6:
			case Canvas.KEY_NUM7:
			case Canvas.KEY_NUM8:
			case Canvas.KEY_NUM9:
				if(keyCode - Canvas.KEY_NUM1 < maxLinePerHeight)
				{
					lineCur = keyCode - Canvas.KEY_NUM1;
					
					canvas.repaint(list_x, list_y, list_width, list_height);
					canvas.serviceRepaints();
				}
				break;
				
			case Canvas.KEY_UP:
				//   0 ...   .
				//  Ʈ øٰ ̻ ö ʰ ϴ 쵵 ִ.
				if(lineCur <= 0)
				{
					//   .
					lineCur = lineMax - 1;
					
					// ȭ ù°  
					// list_height  ū .
					//  ο ȭ鿡 ִ ŭ .
					lineFirst = (lineMax * LIST_PER_LINEHEIGHT <= list_height)?0:lineMax - maxLinePerHeight;
				} else
				{		
					// ù°  ϳ  ø.
					if(lineFirst > lineCur - 1)
						lineFirst--;

					//  ε  ø.
					lineCur--;
				}
				
				// ߿ üũ..

				//  Ŀ   list_height  ũ list_yMove־Ѵ.
				//   Ⱥ̴ ŭ  ø.
				// ̰ ù°ο  ø    .
				if((lineCur + 1) * LIST_PER_LINEHEIGHT > list_height - margin_top - margin_bottom)
					gapHeightOfListAndReal = true;

				// ϴ     list_yMove true Ǽ..
				// ü  ׷ ġ ÷    ߺ̰ Ѵ.
				// ̷  ù°  ణ ̰ ȴ. ׷ ٽ ù°  
				// Ϸ Ŀ ù°  ö ٷ Ѵ.
				if(gapHeightOfListAndReal)
					gapHeightOfListAndReal = lineCur == lineFirst?false:true;
				
				//  Ʈ ŭ repaint() ߴµ Ʈ   ũ  찡
				// ִ 쿡  Ҽ ۿ ...뷫..
				canvas.repaint(list_x, list_y, list_width + 10, list_height);
				canvas.serviceRepaints();
				break;

			case Canvas.KEY_DOWN:
				//    ̸ ù° ̵Ѵ.
				if(lineCur >= lineMax - 1)
				{
					lineFirst = lineCur = 0;
				}else
				{
					// ù°  Ų.
					if(lineFirst + maxLinePerHeight - 1 <= lineCur)
						lineFirst++;

					//   Ų.
					lineCur++;
				}

				//  ̴.
				if((lineCur + 1) * LIST_PER_LINEHEIGHT > list_height - margin_top - margin_bottom)
					gapHeightOfListAndReal = true;

				//  ̴.
				if(gapHeightOfListAndReal)
					gapHeightOfListAndReal = lineCur == lineFirst?false:true;

				//  Ʈ ŭ repaint() ߴµ Ʈ   ũ  찡
				// ִ 쿡  Ҽ ۿ ...뷫..
				// ũ   XListFIeld ؼ ..̴..
				canvas.repaint(list_x, list_y, list_width + 10, list_height);
				canvas.serviceRepaints();
				break;
		}
	}	

	/**
	 * Ȥ Ʈ ش ȣ  ̵ϴ 찡 ִµ ٷ
	 * ̰ ̿ؼ ʸ ϸ Ѵ.
	 * 
	 * @param keyCode
	 */
	protected void keyReleased(int keyCode)
	{
		switch (keyCode)
		{
			case Canvas.KEY_NUM1:
			case Canvas.KEY_NUM2:
			case Canvas.KEY_NUM3:
			case Canvas.KEY_NUM4:
			case Canvas.KEY_NUM5:
			case Canvas.KEY_NUM6:
			case Canvas.KEY_NUM7:
			case Canvas.KEY_NUM8:
			case Canvas.KEY_NUM9:
				if(keyCode - Canvas.KEY_NUM1 < maxLinePerHeight)
					keyNotify(Canvas.KEY_FIRE);
				break;
		}
	}
    
/*
** --------------------------------------------------------------------------------
**  XList Type
** --------------------------------------------------------------------------------
*/
    
    class XListTypeOfEmpty implements XListType
    {
        public int getX()
        {
            return getRealX();
        }
        
        public int getY()
        {
            return getTextY(getSelLine()) + getGapFontHeightOfLine();
        }
        
        public int getWidth()
        {
            return getRealWidth();
        }
        
        public char[] getChars()
        {
            char[] text = new char[list_text[lineCur].length];
            
            System.arraycopy(list_text[lineCur], 0, 
                    text, 0, text.length);
            
            return text;
        }
        
        public void drawBar(Graphics g, int x, int y)
        {
            //   ׸.
            g.setColor(colorSelBar);
            g.fillRect(x, y, list_width, LIST_PER_LINEHEIGHT);
        }

        public void drawList(Graphics g, int x, int y, int line, int color)
        {
            g.setColor(color);
            
            //Ʈ  ׸
            g.drawChars(list_text[line], 0, list_text[line].length, 
                    x, getTextY(line), Graphics.TOP|Graphics.LEFT);
        }
    }

    
    
    class XListTypeOfDefault implements XListType
    {
        public int getX()
        {
            return getRealX() + LIST_ITEM_WIDTH;
        }
        
        public int getY()
        {
            return getTextY(getSelLine()) + getGapFontHeightOfLine();
        }
        
        public int getWidth()
        {
            return getRealWidth() - LIST_ITEM_WIDTH;
        }
        
        public char[] getChars()
        {
            char[] text = new char[list_text[lineCur].length];
            
            System.arraycopy(list_text[lineCur], 0, 
                    text, 0, text.length);
            
            return text;
        }
        
        public void drawBar(Graphics g, int x, int y)
        {
            //   ׸.
            g.setColor(colorSelBar);
            g.fillRect(x, y, list_width, LIST_PER_LINEHEIGHT);
        }

        public void drawList(Graphics g, int x, int y, int line, int color)
        {
            g.setColor(color);
            
            //  ׸
            if(list_num.length - 1 > line)
            {
                g.drawChar(list_num[line], 
                        x, getTextY(line), Graphics.TOP|Graphics.LEFT);
            }else
            {
                g.drawChar(list_num[9], 
                        x, getTextY(line), Graphics.TOP|Graphics.LEFT);
            }
            
            //Ʈ  ׸
            g.drawChars(list_text[line], 0, list_text[line].length, 
                    x + LIST_ITEM_WIDTH, getTextY(line), Graphics.TOP|Graphics.LEFT);
            
        }
    }

    class XListTypeOfIcon implements XListType
    {
        public int getX()
        {
            return getRealX() + LIST_ITEM_WIDTH;
        }
        
        public int getY()
        {
            return getTextY(getSelLine()) + getGapFontHeightOfLine();
        }
        
        public int getWidth()
        {
            return getRealWidth() - LIST_ITEM_WIDTH;
        }
        
        public char[] getChars()
        {
            char[] text = new char[list_text[lineCur].length - 1];
            
            System.arraycopy(list_text[lineCur], 1, 
                    text, 0, text.length);
            
            return text;
        }
        
        public void drawBar(Graphics g, int x, int y)
        {
            //   ׸.
            g.setColor(colorSelBar);
            g.fillRect(x, y, list_width, LIST_PER_LINEHEIGHT);
        }

        public void drawList(Graphics g, int x, int y, int line, int color)
        {
            g.setColor(color);
            
            //  ׸.
            /////////////////////////////////////////////////////////
            
            //Ʈ  ׸
            g.drawChars(list_text[line], 0, list_text[line].length, 
                    x + LIST_PER_LINEHEIGHT, getTextY(line), Graphics.TOP|Graphics.LEFT);
        }
    }
}

interface XListType
{
    abstract int getX();
    abstract int getY();
    abstract int getWidth();
    abstract char[] getChars();
    
    abstract void drawBar(Graphics g, int x, int y);
    abstract void drawList(Graphics g, int x, int y, int line, int color);
}